####################################################
# Blah Software Code      |    Software Version: 1 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2002 e-blah!                  #
# All Rights Reserved                              #
####################################################

sub Admin {
	&is_admin;
	if($URL{'a'} eq 'bkup') { require "$code/Backup.pl"; &BoardBackup; }
	elsif($URL{'a'} eq 'bkupstart') { require "$code/Backup.pl"; &BKUPStart; }
	elsif($URL{'a'} eq 'boards') { &EditBoards; }
	elsif($URL{'a'} eq 'cats') { &EditCats; }
	elsif($URL{'a'} eq 'repop') { &Repop; }
	elsif($URL{'a'} eq 'memgrps') { require("$code/Members.pl"); &MemGrps; }
	elsif($URL{'a'} eq 'temp') { &Temp; }
	elsif($URL{'a'} eq 'temp2') { &Temp2; }
	elsif($URL{'a'} eq 'iplog') { &IPLog; }
	elsif($URL{'a'} eq 'errorlog') { &ErrorLog; }
	elsif($URL{'a'} eq 'attlog') { &AttachLog; }
	elsif($URL{'a'} eq 'clicklog') { &ClickLog; }
	elsif($URL{'a'} eq 'remem') { &Remem; }
	elsif($URL{'a'} eq 'killsids') { &KILLSID; }
	elsif($URL{'a'} eq 'version') { &Version; }
	elsif($URL{'a'} eq 'news') { &News; }
	elsif($URL{'a'} eq 'advipsearch') { require("$code/Members.pl"); &IPSearch; }
	elsif($URL{'a'} eq 'clearactive') { &ClearActive; }
	elsif($URL{'a'} eq 'remove') { require("$code/Moderate.pl"); &OldThreads; }
		else { require("$code/Admin2.pl"); &Admin2; }
}

sub ClearActive {
	unlink("$prefs/Active.txt");
	&redirect("$scripturl,v=admin");
}

sub LoadModifications {
	# When you make a modification to Blah, add it here in the following format:
	  # - push(@bdmod,"Modification Name");
	# YaBB Security Mod
	$ypon = $yabbconver ? 'Enabled' : 'Disabled';
	push(@bdmod,"YaBB Security 1.1.1 (<b>$ypon</b>)");	# This mod is installed by default for boards which used the "YaBB Security Mod"

	# Do not mess with anything below ... it's for adding the mod to the list.
	foreach(@bdmod) { $bdmods .= "$_<br>"; }
	$bdmods =~ s/<br>\Z//;
}

sub AdminCenter {
	&Registry;
	@adminlist = FindRanks('Administrator');
	foreach(@adminlist) { $adminlist .= qq~<a href="$scripturl,v=profile,a=view,u=$_">$userset{$_}->[1]</a>, ~; }
	$adminlist =~ s/, \Z//;

	&LoadModifications;
	fopen(FILE,"$prefs/ReportPM.txt");
	@reports = <FILE>;
	fclose(FILE);
	chomp @reports;
	$reportpm = 0;
	foreach(@reports) {
		($t,$t,$t,$t,$t,$t,$t,$t,$recieveuser,$t,$t) = split(/\|/,$_);
		if($recieveuser eq $username || $recieveuser eq 'all admin') { ++$reportpm; }
	}

	$banninglog = 0;
	$activelog = 0;
	$clicklog = 0;
	$attlog = 0;
	$banlog = 0;
	$felog = 0;
	$areferals = 0;
	$referals = 0;
	$activesids = 0;
	$inactivesids = 0;

	fopen(FILE,"$prefs/ELog.txt");
	while(<FILE>) { ++$felog; }
	fclose(FILE);
	fopen(FILE,"$prefs/BanList.txt");
	while(<FILE>) { ++$banlog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Attachments.txt");
	while(<FILE>) { ++$attlog; }
	fclose(FILE);
	fopen(FILE,"$prefs/ClickLog.txt");
	while(<FILE>) { ++$clicklog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Active.txt");
	while(<FILE>) { ++$activelog; }
	fclose(FILE);
	fopen(FILE,"$prefs/NoAccess.txt");
	while(<FILE>) { ++$banninglog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Refer.txt");
	while(<FILE>) { ++$areferals; }
	fclose(FILE);
	fopen(FILE,"$prefs/ReferLog.txt");
	while(<FILE>) { ++$referals; }
	fclose(FILE);
	fopen(FILE,"$prefs/Sids.sid");
	@sids = <FILE>;
	fclose(FILE);
	chomp @sids;
	foreach(@sids) {
		($t,$t,$t,$t,$endtime,$baccess) = split(/\|/,$_);
		if($endtime > time) { ++$activesids; } else { ++$inactivesids; }
	}
	if($inactivesids) { $inactivesids .= qq~ : <a href="javascript:clear('$scripturl,v=admin,a=killsids')">Delete Old SID's</a>~; }

	opendir(DIR,"$theme/");
	@themes = readdir(DIR);
	closedir(DIR);
	foreach(@themes) {
		$themename = $_;
		$themename =~ s/ /\+/gsi;
		if($_ =~ m/(.*)(.v1)/) { $themes .= qq~$1<br>~; }
	}
	$themes =~ s/<br>\Z//;
	$ENV{'OS'} =~ s/_/ /gsi;

	$title = "Forum Administration Center";
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url,url2,explain) {
 if(!explain) { explain = "Are you sure you would like to do this?"; }
 if(window.confirm(explain)) { location = url; }
  else {
   if(url2) { location = url2; }
  }
}
// -->
</script>
<table bgcolor=$color{'border'} cellpadding="4" cellspacing=1 width=750 align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan=2><font size="2"><b><img src="$images/admin_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="2">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
     <td width="50%" align="center"><font size="1"><b>$mbname :: $title<hr color="$color{'border'}" size="1">$date_time<br>Logged in as: $settings[1]<br>Private Messages: $pmcnt ($new new)</font></b></font></td>
     <td width="50%"><font size="1">Welcome to the administration center, <b>$settings[1]</b>! From this location you can add and change <b>boards</b>, <b>categories</b>, <b>smiley codes</b>, <b>user banning</b>, <b>member groups</b>, along with a ton of other <b>changeable features</b> within the board. You can view logged infomation, such as the <b>Click Log</b> and <b>Ban Log</b>. Help and support are avalible to all registered boards by <a href="http://starsabers.swsource.net/cgi-bin/blah/Blah.pl">clicking here</a>.</font></td>
    </tr>
   </td>
  </table>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" width="50%"><font size="2"><b><img src="$images/open_thread.gif"> Board Setup</b></font></td>
  <td bgcolor="$color{'catbg'}" width="50%"><font size="2"><b><img src="$images/lamp.gif"> Board Information and Statistics</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=sets">Change Board Settings</a></b></font></td>
  <td bgcolor="$color{'win2'}" rowspan="35" width="50%" height="100%" valign="bottom">
   <table cellpadding="2" cellspacing="0" width=100% height="100%">
    <tr>
     <td height="85%" valign="top">
      <table cellpadding="2" cellspacing="1" width="100%">
       <tr>
        <td align="right" valign="top"><font size="2"><b>Registered to:</b></font></td>
        <td><font size="1"><b>$regto</b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Registration ID:</b></font></td>
        <td><font size="1"><b>$regid</b></font></td>
       </tr><tr>
        <td colspan="2"><hr size="1" color="$color{'border'}"></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Administrators:</b></font><br><font size="1"><b> <a href="$scripturl,v=members,a=groups">Display All Groups</a></b></font></td>
        <td valign="top"><font size="1">$adminlist</font></td>
       </tr><tr>
        <td align="right" valign="top" colspan="2"><hr size="1" width="100%" color="$color{'border'}"></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Click Log:</b></font></td>
        <td><font size="1"><b><a href="$scripturl,v=admin,a=clicklog">$clicklog</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Reported PMs:</b></font></td>
        <td><font size="1"><b><a href="$scripturl,v=admin,a=reports">$reportpm</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Active Users:</b></font></td>
        <td><font size="1"><b>$activelog : <a href="javascript:clear('$scripturl,v=admin,a=clearactive')">Clear Current Active Users</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Attachments:</b></font></td>
        <td><font size="1"><b><a href="$scripturl,v=admin,a=attlog">$attlog</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Banned Users:</b></font></td>
        <td><font size="1"><b><a href="$scripturl,v=admin,a=ban">$banlog</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Fatal Error Log:</b></font></td>
        <td><font size="1"><b><a href="$scripturl,v=admin,a=errorlog">$felog</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top" colspan="2"><hr size="1" width="100%" color="$color{'border'}"></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Ban Log:</b></font></td>
        <td><font size="1"><b><a href="$scripturl,v=admin,a=banlog">$banninglog</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Active Referals:</b></font></td>
        <td><font size="1"><b><a href="$scripturl,v=admin,a=referals">$areferals</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Old Referals:</b></font></td>
        <td><font size="1"><b><a href="$scripturl,v=admin,a=referals">$referals</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Active SID's:</b></font></td>
        <td><font size="1"><b>$activesids</b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="2"><b>Old SID's:</b></font></td>
        <td><font size="1"><b>$inactivesids</b></font></td>
       </tr><tr>
        <td colspan="2"><hr size="1" color="$color{'border'}"></td>
       </tr><tr>
        <td align="right" valign="top" width="150"><font size="1"><b>Installed Modifications:</b></font></td>
        <td><font size="1">$bdmods<br><b> <a href="$scripturl,v=admin,a=sourcemod">Install More Modifications</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top" width="150"><font size="1"><b>Installed Themes:</b></font></td>
        <td><font size="1">$themes</font></td>
       </tr><tr>
        <td colspan="2"><hr size="1" color="$color{'border'}"></td>
       </tr><tr>
        <td align="right" valign="top" width="150"><font size="1"><b>Blah Core Version:</b></font></td>
        <td><font size="1">$version<br><b> <a href="$scripturl,v=admin,a=version">Version Check</a></b></font></td>
       </tr><tr>
        <td align="right" valign="top" width="150"><font size="1"><b>Perl Version:</b></font></td>
        <td><font size="1">$] ( 5 Required)</font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td valign="bottom" colspan="2">
      <table cellpadding="2" cellspacing="0" width="100%">
       <tr>
        <td colspan="2" align="center"><font size="1"><b><u>Software Credits</u></b></font></td>
       </tr><tr>
        <td align="right" valign="top" width="150"><font size="1"><b>Very Special Thanks:</b></font></td>
        <td><font size="1"><b><span style="cursor:hand;"><a title="Thank you so, so much for dying for me! I love you!">Jesus</a>, <a title="Allowing me to switch them from Gamers.com to Blah">JFA</a>, <a title="Their support of the Blah Project">FP Community</a>, <a title="Good cell group! :) Thanks for using Blah!!">OOB</a></b></span></font></td>
       </tr><tr>
        <td align="right" valign="top" width="150"><font size="1"><b>Core Development:</b></font></td>
        <td><font size="1"><span style="cursor:hand;">Justin</span></font></td>
       </tr><tr>
        <td align="right" valign="top" width="150"><font size="1"><b>Various Items:</b></font></td>
        <td><font size="1"><b><span style="cursor:hand;"><a title="Helped a little with Attachments, various file opening routines, and text to URL.">Dave B.</a></b></span></font></td>
       </tr><tr>
        <td align="right" valign="top" width="150"><font size="1"><b>Beta Testers:</b></font></td>
        <td><font size="1"><i>Currently None</i></font></td>
       </tr>
      </table>
     </td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=boards">Edit Boards and Catagories</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=smiley">Extra Smiley Code</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=ban">Ban Users</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=censor">Censor Words</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=themesman">Theme Manager</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=advipsearch">Advanced IP Search Utility</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=news">Edit News</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=sourcemod">Modification Center</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" width="50%" valign="top"><font size="2"><b><img src="$images/xx.gif"> Board Templates</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=temp">Edit Board Templates (Includes Smiley)</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=regtemp">Edit Registration Agreement</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" width="50%" valign="top"><font size="2"><b><img src="$images/profile_sm.gif"> Member Setup and Controls</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=memgrps">Change Member Groups</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=reports">Private Message Reports</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="javascript:clear('$scripturl,v=admin,a=mailing','$scripturl,v=admin,a=mailing,s=all','Members may choose to opt out of the mailing list.\\nClicking \\'Cancel\\' will e-mail all members.\\nClicking \\'Ok\\' will only e-mail members that do not opt out.');">Mailing List</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=validate">Validate Members</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" width="50%" valign="top"><font size="2"><b><img src="$images/ban.gif"> Member Maintance</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="javascript:clear('$scripturl,v=admin,a=remem')">Rebuild Member List</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=delspec">Remove Spectators</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=removemembers">Remove Multiple Members</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" width="50%" valign="top"><font size="2"><b><img src="$images/ban.gif"> Board Maintance</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=repop">Rebuild All Messages</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=bkup">Backup Boards</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=remove">Remove Old Threads</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" width="50%" valign="top"><font size="2"><b><img src="$images/clicklog_sm.gif"> Logged Information</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=attlog">Attachment Statistics</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=banlog">Ban Log</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=clicklog">Click Log</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=errorlog">Fatal Error Log</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=iplog">Login - Logout Log</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$scripturl,v=admin,a=referals">Referal Logs</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" width="50%" valign="top"><font size="2"><b><img src="$images/convert.gif"> Conversion Tools</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" valign="top"><font size="1"><b>  <a href="$surl,v=admin,a=convert,t=yabb">YaBB</a></b></font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub KILLSID {
	fopen(FILE,"$prefs/Sids.sid");
	while( $sid = <FILE> ) {
		chomp $sid;
		($tsid,$ip,$sidname,$t,$endtime) = split(/\|/,$sid);
		if($endtime > time) { $othersids .= "$sid\n"; }
	}
	fclose(FILE);
	fopen(FILE,"+>$prefs/Sids.sid");
	print FILE $othersids;
	fclose(FILE);
	&redirect("$scripturl,v=admin");
}

sub Remem {
	opendir(DIR,"$members/");
	@list = readdir(DIR);
	closedir(DIR);
	$memcnt = 0;
	foreach (sort @list) {
		if($_ =~ s/.dat\Z//) {
			&loaduser($_);
			if($userset{$_}->[14] > $lucnt) {
				$luser = $_;
				$lucnt = $userset{$_}->[14];
			}
			if($userset{$_}->[1]) { ++$memcnt; $memlistc .= "$_\n"; }
		}
	}
	fopen(LIST,"+>$members/List.txt");
	print LIST "$memlistc";
	fclose(LIST);
	fopen(FILE,"+>$members/LastMem.txt");
	print FILE "$luser\n$memcnt";
	fclose(FILE);
	if($URL{'v'} eq 'profile' || $URL{'a'} eq 'convert' || $URL{'a'} eq 'delspec' || $URL{'a'} eq 'removemembers') { return; }

	$title = "Rebuild Member List";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding=4 cellspacing=1 width=500 align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="2">The member list and last member file has been successfully rebuilt.</font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub ClickLog {
	if($eclick != 1) { &error("Click logging has been disabled. You must first enable it to access this page."); }
	if($URL{'p'} eq 'delete') {
		fopen(FILE,">$prefs/ClickLog.txt");
		print FILE '';
		fclose(FILE);
		&redirect("$scripturl,v=admin,a=clicklog");
	}

	$title = "Click Log";
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("Are you sure you would like to do this?")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align="center" width="750">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="6"><font size="2"><b><img src="$images/clicklog_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="6"><font size="1">Blah has the most comprehensive logging system, this information may be useful for seeing <b>who refers your board the most</b>, <b>what IP is the most active</b>, or <b>what browser</b> and <b>operating system is most used</b>. To increase how long clicks stay in the log, <b><a href="$scripturl,v=admin,a=sets,l=log">click here</a></b>.</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> IP's Logged</font><font size="1"> (greatest to least, graph)</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan=6>
   <table cellpadding="3" cellspacing="0" width="100%">
EOT
	$totalips = 0;
	$counter = 0;
	fopen(FILE,"$prefs/ClickLog.txt");
	while(<FILE>) {
		chomp;
		($logtime,$ipaddy,$ref[$totalips],$page[$totalips],$info[$totalips]) = split(/\|/,$_);
		if($iplog{$ipaddy} eq '') {
			push(@ipaddyt,"$ipaddy");
			$iplog{$ipaddy} = 1;
		} else { ++$iplog{$ipaddy}; }
		if($page[$totalips] eq '') { $page[$totalips] = 'Board Index'; }
		++$totalips;
	}
	fclose(FILE);
	if(!$totalips) { $totalips = 1; }

	foreach(@ipaddyt) { push(@ipaddy,"$iplog{$_}|$_"); }

	foreach(sort{$b <=> $a} @ipaddy) {
		($t,$ip) = split(/\|/,$_);
		$pper = ($iplog{$ip}/$totalips);
		$pper = sprintf("%.2f",($pper*100));
		print <<"EOT";
    <tr>
     <td align=right width="25%"><font size="2"><b><a href="$scripturl,v=admin,a=advipsearch,s=advsearch,ip=$ip" title="Track This IP Address">$ip</a></b></font> </td>
     <td width="50%"><img src="$images/bar.gif" width="$pper%" height="10" alt="$pper%"></td>
     <td width="25%"><font size="1"> $iplog{$ip} hits ($pper%)</font></td>
    </tr>
EOT
		++$counter;
	}
		print <<"EOT";
    <tr>
     <td width=75% colspan=2 align=right><font size="2"><b>Total Hits: </b></font></td>
     <td width=25%><font size="1"> $totalips hits</font></td>
    </tr><tr>
     <td width=75% colspan=2 align=right><font size="2"><b>Total Unique Hits: </b></font></td>
     <td width=25%><font size="1"> $counter unique hits</font></td>
    </tr>
EOT
	$cntb = 0;
	$cnto = 0;
	for($i = 0; $i < @info; $i++) {
		$fndb = 0;
		$fndo = 0;
		$_ = $info[$i];
		$ost = $_;
		if($ost =~ s/Windows ([A-Za-z0-9. ]{2,8})//) { $os = "Windows $1"; }
		elsif($ost =~ s/Win([ 0-9.]{2,8})//) { $os = "Windows $1"; }
		elsif($ost =~ s/Linux([ 0-9.]{2,8})//) { $os = "Linux $1"; }
			else { $os = "Unknown"; }
		if($ost =~ s/Opera ([0-9.A-Za-z]{2,9})// || $ost =~ s/Opera\/([0-9.A-Za-z]{2,9})//) { $browser = "Opera $1"; }
		elsif($ost =~ s/MSIE ([0-9.A-Za-z]{2,9})//) { $browser = "Microsoft Internet Explorer $1"; }
		elsif($ost =~ s/Netscape ([0-9.A-Za-z]{2,9})//) { $browser = "Netscape $1"; }
		elsif($ost =~ s/Gecko\/([0-9]{4})([0-9]{2})([0-9]{2})//) { $browser = "Gecko ($2.$3.$1)"; }
		elsif($ost =~ s/Gecko//) { $browser = "Gecko"; }
		elsif($ost =~ s/Mozilla\/([0-9.A-Za-z]{2,9})//) { $browser = "Mozilla $1"; }
			else { $browser = "Unknown"; }
		if($os =~ s/NT 5.1//) { $os .= "XP"; }
		foreach (@osr) { if($os eq $_) { $fndo = 1; last; } }
		foreach (@tbro) { if($browser eq $_) { $fndb = 1; last; } }
		if(!$fndb) { push(@tbro,$browser); }
		if(!$fndo) { push(@osr,$os); }
		++$oscnt{$os};
		++$brcnt{$browser};
	}
	print <<"EOT";
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> Operating Systems</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="6"><font size="2">
EOT
	foreach(sort @osr) {
		$percent = sprintf("%.2f",(($oscnt{$_}/$totalips)*100));
		print qq~$_<font size="1">  -  $oscnt{$_} hits ($percent%)</font><br>~;
	}
	print <<"EOT";
  </font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> Browsers</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="6"><font size="2">
EOT
	foreach(sort @tbro) {
		$percent = sprintf("%.2f",(($brcnt{$_}/$totalips)*100));
		print qq~$_<font size="1">  -  $brcnt{$_} hits ($percent%)</font><br>~;
	}
	print <<"EOT";
  </font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> Refering URLs</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="6"><font size="2">
EOT
	$cnt = 0;
	for($i = 0; $i < @ref; $i++) {
		$fnd = 0;
		++$refers{$ref[$i]};
		foreach (@list) {
			if($_ eq "$ref[$i]") { $fnd = 1; last; }
		}
		if(!$fnd && $ref[$i] ne '') { push(@list,$ref[$i]); }
	}
	foreach(@list) { print "<a href=\"$_\">$_</a> ($refers{$_})<br>"; }
	if($list[0] eq '') { print "There have not been any refering pages to this board."; }
	print <<"EOT";
  </font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> Page Hits</font><font size="1"> (greatest to least)</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="6"><font size="2">
EOT
	for($i = 0; $i < @page; $i++) {
		$fnd = 0;
		++$pv{"$page[$i]"};
		foreach (@nlist) {
			if($_ eq "$page[$i]") { $fnd = 1; last; }
		}
		if(!$fnd && $page[$i] ne '') { push(@nlist,$page[$i]); }
	}
	foreach(@nlist) { push(@nlists,"$pv{$_}|$_"); }

	foreach (sort{$b <=> $a} @nlists) {
		($hits,$page) = split(/\|/,$_);
		$percent = sprintf("%.2f",(($hits/$totalips)*100));
		if($page eq 'Board Index') { $vurl = ''; $vname = 'Board Index'; } else { $vurl = $page; $vname = $page; }
		print qq~<a href="$rurl,$vurl">$vname</a><font size="1">  -  $hits hits ($percent%)</font><br>~;
	}
	if($page[0]) { print <<"EOT";
 </font><tr>
  <td bgcolor="$color{'catbg'}" align="center" colspan="6"><font size="1"><a href="javascript:clear('$scripturl,v=admin,a=clicklog,p=delete')"><b>Purge Log</b></a></font></td>
 </tr>
EOT
	}
	print <<"EOT";
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub AttachLog {
	if($URL{'p'} eq 'del2' || $URL{'p'} eq 'del1') { &AttachLog2; }
	elsif($URL{'p'} eq 'extensive') { &AttachLog3; }
	elsif($URL{'p'} eq 'delete') { &AttachLog4; }

	opendir(DIR,"$uploaddir/");
	@dirlist = readdir(DIR);
	closedir(DIR);
	$counter = 0;
	foreach(@dirlist) {
		chomp;
		$fsize = (-s "$uploaddir/$_");
		if($fsize == 0) { next; }
		$size = $size+$fsize;
		++$counter;
	}
	$size = sprintf("%.2f",$size/1024);
	$type = "KB";
	if($size > 1000) { $size = sprintf("%.2f",$size/1024); $type = "MB"; }

	$title = "Attachment Statistics";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="600" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">Each time someone attaches a file to the board, it is logged in a file. This Administrator feature allows you to manage all the uploaded files. The following statistics are not using the log.</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> Attachment Directory Infomation</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}">
   <table cellpadding="2" width="100%">
    <tr>
     <td align="right" width="40%"><font size="2"><b>Number of Attachments:</b></font></td>
     <td width="60%"><font size="2">$counter</font></td>
    </tr><tr>
     <td align="right" width="40%"><font size="2"><b>Size of Attachment Directory:</b></font></td>
     <td width="60%"><font size="2">$size $type</font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> Deletion and Viewing of Files</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}">
   <table cellpadding="2" width="100%">
    <tr><form action="$scripturl,v=admin,a=attlog,p=delete" method="post" name="send">
     <td><font size="1"><b> Delete attachments older than <input type="text" name="days" value="0" maxlength="3" size="6"> days.</b>   <input type="submit" name="submit" value="Remove"></font></td>
    </form></tr><tr><form action="$scripturl,v=admin,a=attlog,p=delete" method="post" name="send">
     <td><font size="1"><b> Delete attachments larger than <input type="text" name="kb" value="0" maxlength="6" size="6"> KBs.</b>   <input type="submit" name="submit" value="Remove"></font></td>
    </form></tr><tr>
     <td><font size="1"><b>  - <a href="$scripturl,v=admin,a=attlog,p=extensive">View The Attachment Log</a></b></font></td>
    </tr>
   </table>
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub AttachLog3 {
	$clog = 1;
	$title = "Extensive Attachment Log";
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("Are you sure you would like to do delete this file?")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="6"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="6"><font size="1">The following shows the attachments currently in your attachment folder.</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" align="center" width="20%"><font size="1"><b>Filename</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="14%"><font size="1"><b>File Size</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="20%"><font size="1"><b>Modify Time</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="20%"><font size="1"><b>Message Subject</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="20%"><font size="1"><b>Posted by</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="6%"><img src="$images/ban.gif"></td>
 </tr>
EOT

	if(!$logip) { print <<"EOT";
 <tr>
  <td colspan=6 align="center" bgcolor="$color{'win'}"><font size="2">Attachments are disabled.</font></td>
 </tr>
EOT
		$clog = 0;
	}
	fopen(FILE,"$prefs/Attachments.txt");
	@attlog = <FILE>;
	fclose(FILE);
	chomp @attlog;
	foreach(@attlog) {
		($aname,$t,$aboard,$amess,$atime,$auser) = split(/\|/,$_);
		$fname{$aname} = "$amess|$auser";
	}

	opendir(DIR,"$uploaddir/");
	@dirlist = readdir(DIR);
	closedir(DIR);

	foreach(@boardbase) {
		($open) = split("/",$_);
		fopen(FILE,"$boards/$open.msg");
		while($tr = <FILE>) {
			($id,$sub) = split(/\|/,$tr);
			$mdat{$id} = "$sub|$aboard";
		}
		fclose(FILE);
	}

	if(!$attlog[0]) { print <<"EOT";
 <tr>
  <td colspan=6 align="center" bgcolor="$color{'win'}"><font size="2">There are currently no attachments logged.</font></td>
 </tr>
EOT
		$clog = 0;
	} else {
		foreach(sort{lc($b) cmp lc($a)} @dirlist) {
			if($_ eq '.' || $_ eq '..') { next; }
			$size = (-s"$uploaddir/$_");
			$size = sprintf("%.2f",$size/1024);
			$type = "KB";
			if($size > 1000) { $size = sprintf("%.2f",$size/1024); $type = "MB"; }
			$fdate = (stat("$uploaddir/$_"))[9];
			$message = "Not Avalible";
			$posted = "Not Avalible";
			if($fname{$_}) {
				($amess,$auser) = split(/\|/,$fname{$_});
				if($mdat{$amess} eq '') { $mdat{$amess} = "Not Avalible|"; }
				($subject,$aboard) = split(/\|/,$mdat{$amess});
				$message = qq~<a href="$surl,b=$aboard,v=display,m=$amess">$subject</a>~;
				loaduser($auser);
				if($userset{$auser}->[1]) { $posted = qq~<a href="$scripturl,v=profile,a=view,u=$auser">$userset{$auser}->[1]</a>~; } else { $posted = $auser; }
			}
			$date = get_date($fdate);

			print <<"EOT";
 <tr>
  <td bgcolor="$color{'win2'}" align="center"><font size="1"><a href="$scripturl,v=download,d=1,f=$_" target="download">$_</a></font></td>
  <td bgcolor="$color{'win'}" align="center"><font size="1">$size $type</font></td>
  <td bgcolor="$color{'win2'}" align="center"><font size="1">$date</font></td>
  <td bgcolor="$color{'win'}" align="center"><font size="1">$message</td>
  <td bgcolor="$color{'win2'}" align="center"><font size="1">$posted</font></td>
  <td bgcolor="$color{'win'}" align="center" width="6%"><font size="1"><a href="javascript:clear('$scripturl,v=admin,a=attlog,p=del1,f=$_')"><img src="$images/ban.gif" border="0"></a></font></td>
 </tr>
EOT
		}
	}
	print "</table>";
	&footer;
	exit;
}

sub AttachLog4 {
	opendir(DIR,"$uploaddir/");
	@dirlist = readdir(DIR);
	closedir(DIR);
	$counter = 0;
	if($FORM{'days'}) {
		$maxdays = ($FORM{'days'}*86400);
		$great = time-$maxdays;
	}
	$deleted = 0;
	foreach(@dirlist) {
		chomp;
		if($_ eq '.' || $_ eq '..') { next; }
		$fsize = sprintf("%.2f",((-s "$uploaddir/$_"))/1024);
		$fdate = (stat("$uploaddir/$_"))[9];
		if($FORM{'days'} && $fdate < $great) {
			++$deleted;
			push(@remove,$_);
		}
		if($FORM{'kb'} && $FORM{'kb'} < $fsize) {
			++$deleted;
			push(@remove,$_);
		}
		if($fsize == 0) { next; }
		$size = $size+$fsize;
		++$counter;
	}

	foreach(@remove) { unlink ("$uploaddir/$_","$prefs/Hits/$_.txt"); }
	fopen(FILE,"$prefs/Attachments.txt");
	@att = <FILE>;
	fclose(FILE);
	chomp @att;
	fopen(FILE,"+>$prefs/Attachments.txt",1);
	foreach(@att) {
		$next = 0;
		($fnamez) = split(/\|/,$_);
		foreach $ds (@remove) {
			if($fnamez eq $ds) { $next = 1; next; }
		}
		if($next) { next; }
		print FILE "$_\n";
	}
	fclose(FILE);
}

sub AttachLog2 {
	unlink ("$uploaddir/$URL{'f'}");
	unlink ("$prefs/Hits/$URL{'f'}.txt");
	fopen(FILE,"$prefs/Attachments.txt");
	@att = <FILE>;
	fclose(FILE);
	fopen(FILE,"+>$prefs/Attachments.txt",1);
	foreach (@att) {
		chomp;
		($fnamez) = split(/\|/,$_);
		if($fnamez ne $URL{'f'}) { print FILE "$_\n"; }
	}
	fclose(FILE);
	&redirect("$scripturl,v=admin,a=attlog,p=extensive");
}

sub ErrorLog {
	if($URL{'p'} eq 'delete') {
		unlink("$prefs/ELog.txt");
		&redirect("$scripturl,v=admin,a=errorlog");
	}
	$clog = 1;

	$title = "Fatal Error Log";
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("Are you sure you would like to do this?")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="100%">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="4"><font size="2"><b><img src="$images/ban.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="4"><font size="1">Whenever a user encounters an error, such as "Unable to open Board.msg", it will be logged here. In other words this will log all fatal errors that occur on this board.</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="4"><font size="2"><b> Fatal Errors in Log</b></font></td>
 </tr>
EOT

	if(!$logip) { print <<"EOT";
 <tr>
  <td colspan="5" align="center" bgcolor="$color{'win'}"><font size="2"><b>Logging is currently turned off.</b></font></td>
 </tr>
EOT
		$clog = 0;
	}
		fopen(FILE,"$prefs/ELog.txt");
		@elog = <FILE>;
		fclose(FILE);
		if(!$elog[0] && $kelog) { print <<"EOT";
 <tr>
  <td colspan="5" align="center" bgcolor="$color{'win'}"><font size="2"><b>There are currently no errors logged.</b></font></td>
 </tr>
EOT
		$clog = 0;
	} else {
		foreach (reverse @elog) {
			chomp;
			($desc,$reason,$logtime,$lusername,$url) = split (/\|/,$_);
			&loaduser($lusername);
			if($userset{$lusername}->[1] eq '') { $userset{$lusername}->[1] = $lusername; }
				else { $userset{$lusername}->[1] = qq~<a href="$scripturl,v=profile,a=view,u=$lusername">$userset{$lusername}->[1]</a>~; }
			$loggedtime = &get_date($logtime);
			$alinkurl = qq~<a href="$url" title="Location of Error">~;
			$url =~ s~(\C{20})~$1 $2~gsi;
			print <<"EOT";
 <tr>
  <td bgcolor="$color{'win2'}"><font size="2">$desc</font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1"><b>Time of Occurence:</b> $loggedtime | <b>Occured By:</b> $userset{$lusername}->[1] | <b>URL:</b> $alinkurl $url</font></td>
 </tr>
EOT
		}
	}

	if($clog) { print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" align="center" colspan="4"><font size="1"><a href="javascript:clear('$scripturl,v=admin,a=errorlog,p=delete')"><b>Clear (or delete) Log</b></a></font></td>
 </tr>
EOT
	}

	print "</table>";
	&footer;
	exit;
}

sub IPLog {
	if($URL{'p'} eq 'delete') {
		unlink("$prefs/IpLog.txt");
		&redirect("$scripturl,v=admin,a=iplog");
	}
	$clog = 1;

	$title = "Login - Logout Log";
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("Are you sure you would like to do this?")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="4"><font size="2"><b><img src="$images/login_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="4"><font size="1">This is the log in which is modified each time a member logs on or off. This infomation is good for several reasons, including people that got access (accuired a password from someone) to another users account. Sorted by time.</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" align="center" width="25%"><font size="1"><b>Username</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="20%"><font size="1"><b>Action</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="25%"><font size="1"><b>IP Address</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="30%"><font size="1"><b>Time</b></font></td>
 </tr>
EOT

	if(!$logip) { print <<"EOT";
 <tr>
  <td colspan="4" align="center" bgcolor="$color{'win'}"><font size="2"><b>Logging is currently turned off.</b></font></td>
 </tr>
EOT
		$clog = 0;
	}
		fopen(FILE,"$prefs/IpLog.txt");
		@iplog = <FILE>;
		fclose(FILE);
		if(!$iplog[0] && $logip == 1) { print <<"EOT";
 <tr>
  <td colspan="4" align="center" bgcolor="$color{'win'}"><font size="2"><b>There are currently no login's or logout's logged.</b></font></td>
 </tr>
EOT
		$clog = 0;
	} else {
		foreach (reverse @iplog) {
			chomp;
			($lusername,$loginout,$ipaddr,$logtime) = split (/\|/,$_);
			&loaduser($lusername);
			if($userset{$lusername}->[1] eq '') { $userset{$lusername}->[1] = $lusername; }
				else { $userset{$lusername}->[1] = qq~<a href="$scripturl,v=profile,a=view,u=$lusername">$userset{$lusername}->[1]</a>~; }
			$loginout = $loginout == 1 ? "Login" : "Logout";
			$loggedtime = &get_date($logtime);
			print <<"EOT";
 <tr>
  <td bgcolor="$color{'win'}" align="center"><font size="2">$userset{$lusername}->[1]</font></td>
  <td bgcolor="$color{'win2'}" align="center"><font size="2">$loginout</font></td>
  <td bgcolor="$color{'win'}" align="center"><font size="2">$ipaddr</font></td>
  <td bgcolor="$color{'win2'}" align="center"><font size="1">$loggedtime</font></td>
 </tr>
EOT
		}
	}

	if($clog) { print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" align="center" colspan="4"><font size="1"><b><a href="javascript:clear('$scripturl,v=admin,a=iplog,p=delete')">Clear IP Log</a></b></font></td>
 </tr>
EOT
	}

	print "</table>";
	&footer;
	exit;
}

sub Temp {
	fopen(FILE,"$root/template.pl") || &error("Cannot open 'template.pl'!",1);
	@stemp = <FILE>;
	fclose(FILE);
	chomp @stemp;
	$lifes = 0;
	foreach (@stemp) {
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		if($_ eq "\}") { $extras = 0; }
		if($_ eq "EOT") { $lifes = 0; $deaths = 0; $extras = 0; }
		if($lifes) { $life .= "\n"; $life .= "$_"; }
		if($_ eq qq~\$header = &lt;&lt;"EOT";~) { $lifes = 1; }
		if($deaths) { $death .= "\n"; $death .= "$_"; }
		if($_ eq qq~\$footer = &lt;&lt;"EOT";~) { $deaths = 1; }
		if($extras) { $extra .= "\n"; $extra .= "$_"; }
		if($_ eq "sub ExtraTemp \{") { $extras = 1; $checked = " checked"; }
	}
	fopen(FILE,"$prefs/Smilies.pl");
	@stemp = <FILE>;
	fclose(FILE);
	chomp @stemp;
	$lifes = 0;
	foreach (@stemp) {
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		if($_ eq "\}") { $extras = 0; }
		if($_ eq "EOT") { $lifes = 0; $deaths = 0; $extras = 0; }
		if($lifes) { $life2 .= "\n"; $life2 .= "$_"; }
		if($_ eq qq~\$header = &lt;&lt;"EOT";~) { $lifes = 1; }
		if($deaths) { $death2 .= "\n"; $death2 .= "$_"; }
		if($_ eq qq~\$footer = &lt;&lt;"EOT";~) { $deaths = 1; }
		if($extras) { $extra2 .= "\n"; $extra2 .= "$_"; }
		if($_ eq "sub ExtraTemp \{") { $extras = 1; $checked2 = " checked"; }
	}
	$title = "Edit Default Templates";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="100%" align="center">
 <tr><form action="$scripturl,v=admin,a=temp2" method="post" name="post">
  <td bgcolor="$color{'titlebg'}" width="50%"><font size="2"><b><img src="$images/xx.gif"> Main Template</b></font></td>
  <td bgcolor="$color{'titlebg'}" width="50%"><font size="2"><b><img src="$images/smiley.gif"> Smilies Template</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="2"><b> Header</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" align="center"><textarea rows="10" cols="90" name="header">$life</textarea></td>
  <td bgcolor="$color{'win'}" align="center"><textarea rows="10" cols="90" name="header2">$life2</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="2"><b> Footer</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" align="center"><textarea rows="10" cols="90" name="footer">$death</textarea></td>
  <td bgcolor="$color{'win2'}" align="center"><textarea rows="10" cols="90" name="footer2">$death2</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="2"><b> Perl Code</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="2"><font size="1">This is extra perl code! If you do not know perl, <b>please</b> do not attempt to fill the fields in.</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}">
   <table cellpadding="4" cellspacing=0 width="100%">
    <tr>
     <td align="right" width="35%"><font size="1"><b>Use perl code?</b></font></td>
     <td width="65%"><input type="checkbox" name="extracheck" value="1"$checked></td>
    </tr>
   </table>
  </td>
  <td bgcolor="$color{'win2'}">
   <table cellpadding="4" cellspacing=0 width="100%">
    <tr>
     <td align="right" width="35%"><font size="1"><b>Use perl code?</b></font></td>
     <td width="65%"><input type="checkbox" name="extracheck2" value="1"$checked2></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win'}" align="center"><textarea rows="10" cols="90" name="extra">$extra</textarea></td>
  <td bgcolor="$color{'win'}" align="center"><textarea rows="10" cols="90" name="extra2">$extra2</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" align="center" colspan="2"><input type="submit" name="submit" value="Save"></td>
 </form></tr>
</table>
EOT

	&footer;
	exit;
}

sub Temp2 {
	$FORM{'header'} =~ s/EOT/<!>EOT/gi;
	$FORM{'header'} =~ s/\@/\\@/gi;
	$FORM{'header'} =~ s/\\/\\\\/gi;
	$FORM{'footer'} =~ s/EOT/<!>EOT/gi;
	$FORM{'footer'} =~ s/\@/\\@/gi;
	$FORM{'footer'} =~ s/\\/\\\\/gi;
	fopen(FILE,"+>$root/template.pl",1);
	if($FORM{'extracheck'} == 1) {
		print FILE <<"TEMP";
\&ExtraTemp;
sub ExtraTemp \{
$FORM{'extra'}
\}

TEMP
	}
	print FILE <<"TEMP";
\$header = <<"EOT";
$FORM{'header'}
EOT

\$footer = <<"EOT";
$FORM{'footer'}
EOT
1;
TEMP
	fclose(FILE);

	$FORM{'header2'} =~ s/EOT/<!>EOT/gi;
	$FORM{'header2'} =~ s/\@/\\@/gi;
	$FORM{'header2'} =~ s/\\/\\\\/gi;
	$FORM{'footer2'} =~ s/EOT/<!>EOT/gi;
	$FORM{'footer2'} =~ s/\@/\\@/gi;
	$FORM{'footer2'} =~ s/\\/\\\\/gi;
	fopen(FILE,"+>$prefs/Smilies.pl",1);
	if($FORM{'extracheck2'} == 1) {
		print FILE <<"TEMP";
\&ExtraTemp;
sub ExtraTemp \{
$FORM{'extra2'}
\}

TEMP
	}
	print FILE <<"TEMP";
\$header = <<"EOT";
$FORM{'header2'}
EOT

\$footer = <<"EOT";
$FORM{'footer2'}
EOT
1;
TEMP
	fclose(FILE);
	&redirect("$scripturl,v=admin");
}

sub Repop {
	if($URL{'p'} eq '') {
		$title = "Rebuild Messages";
		&header;
		print <<"EOF";
<table bgcolor="$color{'border'}" cellpadding=4 cellspacing=1 align="center" width=500>
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">Rebuilding all messages on this board will reorganize this board (deleting double posts, off count posts, etc). It is recomended that this be run every once in a while.</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}"><font size="2"><b> <a href="$scripturl,v=admin,a=repop,p=start">Start Rebuild</a></b></font><br><font size="1">  - Please remember this board <b>must</b> be in "Maintenance Mode" to use this feature. Depending on the websever and size of the board, this could take several minutes.</font></td>
 </tr>
</table>
EOF
		&footer;
		exit;
	}
	if(!$maintance) { &error("You must be in maintaince mode to rebuild messages. Rebuilding messages is risky while not operating in maintaince mode (due to the fact that vital files needs to be written to while rebuilding messages)."); }
	foreach(@boardbase) {
		($cgs) = split("/",$_);
		fopen(FILE,"$boards/$cgs.msg");
		@msg = <FILE>;
		fclose(FILE);
		chomp @msg;
		$number = 0;
		$replycount = 0;
		@output = '';
		$puser = 0;
		$ptime = 0;
		foreach $msgs (@msg) {
			($tmess,$a,$b,$c,$replies,$poll,$f,$g) = split(/\|/,$msgs);
			$curnumber = -1;
			if($inu{$tmess}) { next; }
			fopen(FILE,"$messages/$tmess.txt") || next;
			while( $countz = <FILE> ) {
				chomp $countz;
				($posted,$t,$t,$t,$lp) = split(/\|/,$countz);
				++$curnumber;
			}
			fclose(FILE);
			$replycount = $curnumber+$replycount;
			++$number;
			$inu{$tmess} = 1;
			if($poll) {
				fopen(FILE,"$messages/$tmess.polled");
				@last = <FILE>;
				fclose(FILE);
				chomp @last;
				$lloc = @last-1;
				($poller,$ptime) = split(/\|/,$last[$lloc]);
				if($ptime && $ptime > $lp) { $posted = $poller; $lp = $ptime; }
			}
			push(@output,"$lp|$tmess|$a|$b|$c|$curnumber|$poll|$f|$g|$posted");
		}
		$find = 0;
		fopen(FILE,"+>$boards/$cgs.msg");
		foreach $last (sort{$b <=> $a} @output) {
			($lp,$tmess,$a,$b,$c,$curnumber,$e,$f,$g,$posted) = split(/\|/,$last);
			if($find == 0) { $puser = $posted; $ptime = $lp; ++$find; }
			if($tmess eq '') { next; }
			print FILE "$tmess|$a|$b|$c|$curnumber|$e|$f|$g|$lp|$posted\n";
		}
		fclose(FILE);
		$replycount = $replycount+$number;
		fopen(FILE,"+>$boards/$cgs.ino");
		print FILE "$number\n$replycount\n";
		fclose(FILE);
	}
	if($URL{'a'} eq 'remove') { return; }
	$title = "Rebuild Finished";
	&header;
	print <<"EOF";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align="center" width="400">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" align="center"><font size="2">All messages have been rebuilt.</font></td>
 </tr>
</table>
EOF
	&footer;
	exit;
}

sub EditCats {
	require("$code/ManageCats.pl");
	&EditCatsR;
	exit;
}

sub EditBoards {
	require("$code/ManageBoards.pl");
	if($URL{'g'} eq '2') { &EditBoards2; }
	elsif($URL{'g'} eq '3') { &EditBoards3; }
	if($URL{'p'} eq 'move') { &MoveBoards; }
	if($URL{'p'} eq 'moveboard') { &MoveToCat; }
	&StartBoards;
}

sub Version {
	$title = "Version Check";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="500" align="center">
 <tr><form action="http://starsabers.swsource.net/check.php" method="post" name="check">
  <td bgcolor="$color{'titlebg'}"><font size="2"><b> Version Check</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">The following shows your version of Blah, to check to see if you are using the current version we must connect to our servers and check your version (only your version will be sent, no further infomation will be sent).</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}"><input type="hidden" name="version" value="$version"><font size="2"><b>e-Blah System Version:</b> $version</font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><input type="submit" value=" Check Versions "></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub News {
	if($URL{'p'} == 2) {
		fopen(FILE,"+>$prefs/News.txt");
		print FILE "$FORM{'news'}";
		fclose(FILE);
		&redirect("$scripturl,v=admin,a=news");
	}
	fopen(FILE,"$prefs/News.txt");
	@news = <FILE>;
	fclose(FILE);
	chomp @news;
	foreach(@news) { $news .= "$_\n"; }
	$title = "Change News";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellspacing="1" cellpadding="4" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/news.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">If enabled, the news will appear on the homepage. One news item per line.</font></td>
 </tr><tr><form action="$scripturl,v=admin,a=news,p=2" method="post" name="msend">
  <td bgcolor="$color{'win2'}"><textarea name="news" wrap="virtual" rows="8" cols="100">$news</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><input type="submit" value=" Save "></td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}
1;