####################################################
# Blah Software Code      |    Software Version: 1 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2002 e-blah!                  #
# All Rights Reserved                              #
####################################################

sub is_admin {
	if($settings[4] ne 'Administrator') { &error("$txt['705']-admin-"); }
}

sub is_mod {
	if($settings[4] ne 'Administrator' && !$ismod) { &error($txt['706']); }
}

sub is_member {
	if($vradmin == 1) { $extra = " $txt['707']"; }
	if($settings[1] eq '' && $username ne 'Guest') { &error("$txt['708']$extra"); }
}

sub CheckCookies {
	foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
		$_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		($cname,$cval) = split(/=/);
		$Blah{$cname} = $cval;
	}
	if($URL{'sid'} && $Blah{$cookpw} eq '') {
		# This is a running sid, find the user in the sid db.
		fopen(FILE,"$prefs/Sids.sid");
		while( $sid = <FILE> ) {
			chomp $sid;
			($tsid,$ip,$username,$password,$endtime,$baccess) = split(/\|/,$sid);
			if($sid == $URL{'sid'} && $ip eq $ENV{'REMOTE_ADDR'} && $endtime > time) { $sidfnd = 1; $sidinuse = 1; last; }
		}
		fclose(FILE);
		if(!$sidfnd) { $username = ''; $password = ''; }
		&GetUser;
	} elsif($Blah{$cookpw}) {
		$password = $Blah{$cookpw};
		$username = $Blah{$cooknme};
		&GetUser;
	} else { $password = ''; $username = 'Guest'; }
	$scripturl = "Blah.pl?b=$URL{'b'}$usert";
	$surl = "Blah.pl?$usert";
	$rurl = "$realurl/Blah.pl?";
}

sub GetUser {
	my(@temp);
	fopen(FILE,"$members/$username.dat") or $username = "Guest";
	@temp = <FILE>;
	fclose(FILE);
	chomp @temp;
	if($yabbconver) { $cryptpw = $temp[0]; } else { $cryptpw = crypt("$temp[0]",$pwcry); }
	if($temp[23]) { return; }

	if($password ne $cryptpw) { $username = 'Guest'; $password = ''; return; }
	if($URL{'sid'} && $Blah{$cookpw} eq '') { $usert = ",sid=$URL{'sid'}"; }
	$usersetcount = 30; # Update if more values (real cnt).
	@settings = @temp;
}

sub BoardCheck {
	my($bfnd);

	fopen(FILE,"$boards/bdscats.db");
	@catbase = <FILE>;
	fclose(FILE);
	chomp @catbase;

	fopen(FILE,"$boards/bdindex.db");
	@boardbase = <FILE>;
	fclose(FILE);
	chomp @boardbase;

	if($URL{'v'} eq '' || $URL{'b'} eq '') { return; }

	$bfnd = 1;
	foreach (@boardbase) {
		($boardid,$binfo[0],$binfo[1],$binfo[2],$binfo[3],$binfo[4],$binfo[5],$binfo[6],$binfo[7]) = split("/",$_);
		if($URL{'b'} eq $boardid) { $bfnd = 0; last; }
	}
	if($bfnd) { &error("The board you chose isn't valid."); }
	@mods = split(/\|/,$binfo[1]);
	foreach (@mods) { if($username eq $_) { $ismod = 1; last; } }

	foreach (@catbase) {
		($nme,$id,$grps,$input) = split(/\|/,$_);
		if($input ne '') { @cats = split("/",$input); } else { next; }
		foreach (@cats) {
			if($_ eq $URL{'b'}) { $catid = $id; $memgrp = $grps; last; }
		}
	}
	if($memgrp ne '') {
		$con = '';
		@mgrps = split(",",$memgrp);
		foreach $grp (@mgrps) { if($grp eq $settings[4]) { $con = 1; } }
		if($con eq '' && $settings[4] ne 'Administrator') { &error($txt['709']); }
	}
	if($binfo[6] ne '') { require("$code/BoardLock.pl"); &Password; }
	$boardnm = $binfo[2];
}

sub Mods {
	if(@mods == 1) { $modz = "$txt['711']: "; }
	elsif(@mods > 1) { $modz = "$txt['671']: "; }
		else { $modz = "$txt['712']"; }
	foreach (@mods) {
		&loaduser($_);
		$modz .= qq!<a href=$scripturl,v=profile,a=view,u=$_>$userset{$_}->[1]</a>, !;
	}
	$modz =~ s/, \Z//gi;
	if(@mods > 1) { $mds = "s"; }
}

sub loaduser {
	my($user) = $_[0];
	if($userset{$user}->[1]) { return; } # User is already loaded! We don't need more cycles of this routines!
	fopen(FILE,"$members/$user.dat");
	@loaduser = <FILE>;
	fclose(FILE);
	for($i = 0; $i < @loaduser; $i++) {
		chomp $loaduser[$i];
		$userset{$user}->[$i] = $loaduser[$i];
	}
}

sub LMG {
	fopen(FILE,"$prefs/Ranks.txt");
	@memgrps = <FILE>;
	fclose(FILE);
	chomp @memgrps;
	$cnt = 0;
	foreach(@memgrps) {
		($grpname,$grpper) = split(/\|/,$_);
		$memgrps[$cnt] = $grpname;
		$memgrpp[$cnt] = $grpper;
		++$cnt;
	}
	&LMGS;
}

sub loaduserdisplay {
	my($user) = $_[0];
	my($memberstar,$memberpic,$membericq,$memberaim,$membermsn,$memberpost,$ppd,$memberyim);

	if($userset{$user}->[1] eq '') { &loaduser($user); }
	$guest = 0;
	if($userset{$user}->[1] eq '') {
		$membername = $user;
		$memberstat = "Guest";
		$mprofile = '';
		$guest = 1;
		return;
	}
	$membername = qq~<a href="$scripturl,v=profile,a=view,u=$user">$userset{$user}->[1]</a>~;

	if($userset{$user}->[3] >= $maxcount) {
		$memberstat = $memgrps[1];
		$memberstar = '5star';
	} elsif($userset{$user}->[3] >= $bigcount) {
		$memberstat = $memgrps[2];
		$memberstar = '4star';
	} elsif($userset{$user}->[3] >= $medcount) {
		$memberstat = $memgrps[3];
		$memberstar = '3star';
	} elsif($userset{$user}->[3] >= $mincount) {
		$memberstat = $memgrps[4];
		$memberstar = '2star';
	} else {
		$memberstat = $memgrps[5];
		$memberstar = '1star';
	}
	if($userset{$user}->[4] ne '') {
		$team = '';
		if($team{$userset{$user}->[4]}) { $team = qq~<img src="$images/team.gif" alt="$gtxt{'29'}"> ~; }
		if($star{$userset{$user}->[4]} || $team) { $memberstat = qq~<b>$userset{$user}->[4]</b>~; }
			else { $memberstat .= "<br><i>$userset{$user}->[4]</i>"; }
		$memberstat = "$team$memberstat";
		if($star{$userset{$user}->[4]}) { $memberstar = $star{$userset{$user}->[4]}; }
	}
	foreach (@mods) {
		if($user eq $_) {
			$memberstat = qq~$team1 <b>$memgrps[6]</b>~;
			$memberstar = 'starmod';
			last;
		}
	}
	if($userset{$user}->[4] eq 'Administrator') {
		$memberstat = qq~<img src="$images/team.gif" alt="$gtxt{'29'}"> <b>$memgrps[0]</b>~;
		$memberstar = 'staradmin';
	}
	$memberstar = qq~<img src="$images/$memberstar.gif">~;
	$memberstat = $memberstat;

	if($userset{$user}->[5] && $apic) {
		if($userset{$user}->[5] =~ /\//) { $memberpic = qq~<img src="$userset{$user}->[5]" width="$picwidth" height="$picheight">~; }
			else { $memberpic = qq~<img src="$avsurl/$userset{$user}->[5]">~; }
	}

	if($userset{$user}->[12] && $hmail) { $memberemail = ''; }
		else { $memberemail = qq~<a href="mailto:$userset{$user}->[2]">$img{'email'}</a> $msp~; }

	$memberpost = "<b>$txt[557]:</b> $userset{$user}->[3]<br>";
	if($userset{$user}->[9]) { $memberaim = qq~<a href="aim:goim?screenname=$userset{$user}->[9]&message=You+there?" title="$txt['240'] ($userset{$user}->[9])"><img src="$images/aim.gif" border="0"></a>~; }
	if($userset{$user}->[10]) { $membermsn = qq~<img src="$images/msn.gif" alt="$userset{$user}->[10]">~; }
	if($userset{$user}->[8]) { $membericq = qq~<a href="http://wwp.icq.com/scripts/search.dll?to=$userset{$user}->[8]" target="icq"><img src="$images/icqadd.gif" alt="$userset{$user}->[8]" border="0">~; }
	if($userset{$user}->[27]) { $memberyim = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$userset{$user}->[27]" target="yim"><img src="$images/yim.gif" alt="$userset{$user}->[27]" border="0"></a>~; }
	if($userset{$user}->[11]) { $message .= qq~<hr size="1" color="$color{'border'}"><font size="1">$userset{$user}->[11]</font>~; }
	if($showgender) {
		if($userset{$user}->[7] == 1) { $pic = "male"; $gen = $txt['233']; }
		elsif($userset{$user}->[7] == 2) { $pic = "female"; $gen = $txt['234']; }
		$gender = qq~<b>Gender:</b> <img src="$images/$pic.gif"> <b>$gen</b>~;
		if(!$userset{$user}->[7]) { $gender = ''; }
	}
	if($sppd) {
		($t,$t,$t,$lday,$lmonth,$lyear,$lweek) = localtime($userset{$user}->[14]);
		($t,$t,$t,$cday,$cmonth,$cyear,$cweek) = localtime(time);
		$lyear = substr($lyear,-2);
		$cyear = substr($cyear,-2);
		++$lmonth; ++$cmonth;
		$reg = (365*$lyear)+(30.42*$lmonth)+$lday;
		$now = (365*$cyear)+(30.42*$cmonth)+$cday;
		$days = ($now-$reg) || 1;
		$ppd = "<b>$txt['713']: </b>".sprintf("%.2f", $userset{$user}->[3]/$days);
	}
	$mprofile = qq~$memberstar<br><br> <center>$memberpic<br> $userset{$user}->[6]<br><br>$membericq $memberaim $memberyim $membermsn</center>$gender<br>$memberpost $ppd~;
}

sub LogPage {
	my($lid,$ltime,$found,$lltime);
	if($username eq 'Guest') { return; }
	fopen(FILE,"$members/$username.log");
	@log = <FILE>;
	fclose(FILE);
	chomp @log;

	$lltime = (time+2); # +2 prevents "Your New Post == New".

	fopen(FILE,"+>$members/$username.log");
	if($URL{'m'} ne '') { print FILE "$URL{'m'}|$lltime\n"; }
	print FILE "$URL{'b'}|$lltime\n";
	foreach (@log) {
		($lid,$ltime) = split(/\|/,$_);
		if($lid ne $URL{'m'} && $lid ne $URL{'b'} && $ltime+($logdays*86400) > time) { print FILE "$_\n"; }
	}
	fclose(FILE);
}

sub LMGS {
	if($settings[4] eq 'Administrator') { return; }
	for($i = 7; $i < @memgrps; $i++) {
		if($settings[4] eq $memgrps[$i]) {
			($ip,$mod,$st,$m,$pro) = split(',',$memgrpp[$i]);
			$ipon = $ip; $modon = $mod; $ston = $st;
			$modifyon = $m; $proon = $pro;
			last;
		}
	}
}

sub GMS {
	for($q = 0; $q < @memgrps; $q++) {
		($t,$t,$t,$t,$t,$star,$team) = split(',',$memgrpp[$q]);
		$star{$memgrps[$q]} = $star;
		$team{$memgrps[$q]} = $team;
	}
}

sub Ban {
	fopen(FILE,"$prefs/BanList.txt");
	@banlist = <FILE>;
	fclose(FILE);
	chomp @banlist;
	foreach (@banlist) {
		($ipaddy,$banlimit,$bantime) = split(/\|/,$_);
   		$length = length($ipaddy);
   		$ipsearch = substr($ENV{'REMOTE_ADDR'},0,$length);
		if($ipsearch =~ /\Q$ipaddy/i || $username eq $ipaddy) { require("$code/BoardLock.pl"); &Banned($banlimit,$bantime); }
	}
}

sub FindRanks {
	($frank) = $_[0];
	@rdata = ();
	fopen(FILE,"$members/List.txt");
	@list = <FILE>;
	fclose(FILE);
	chomp @list;
	foreach(@list) {
		loaduser($_);
		if($userset{$_}->[4] eq $frank) { push(@rdata,$_); }
	}
	return(@rdata);
}

sub Format {
	($temp) = $_[0];
	$temp =~ s/\&/\&amp;/g;
	$temp =~ s/</&lt;/g;
	$temp =~ s/>/&gt;/g;
	$temp =~ s/\cM//g;
	$temp =~ s/\n/<br>/g;
	$temp =~ s/\|/\&#124;/g;
	$temp =~ s/  / /gi;
	return $temp;
}

sub Unformat {
	($temp) = $_[0];
	$temp =~ s/\&amp;/\&/g;
	$temp =~ s/&lt;/</g;
	$temp =~ s/&gt;/>/g;
	$temp =~ s/<br>/\n/g;
	$temp =~ s/  / /gi;
	return $temp;
}

sub BoardProperties {
	if($binfo[6]) { $pwed .= "$txt['118']"; } else { $pwed = $var{'80'}; }
	if($memgrp) { $pwed .= " ($var{'81'})"; }
	if($noguestp == 0 && $noguest == 0) { $guesta = " $var{'82'}"; }
	if($binfo[3] == 1) { $sthreads = $var{'83'}; }
	elsif($binfo[3] == 2) { $sthreads = $var{'84'}; }
	elsif($binfo[3] == 3) { $sthreads = $var{'85'}; }
		else { $sthreads = "$var{'83'}$guesta"; }
	if($binfo[4] == 1) { $rthreads = $var{'83'}; }
	elsif($binfo[4] == 2) { $rthreads = $var{'84'}; }
	elsif($binfo[4] == 3) { $rthreads = $var{'85'}; }
		else { $rthreads = "$var{'83'}$guesta"; }
	$polling = $binfo[5] ? $txt['492'] : $txt['714'];
	$attachments = $uallow ? $txt[714] : $txt[492];
}

sub ListBoards {
	if(!$boardbase[1]) { return("<font size=\"1\">$boardnm ($txt['715'])</font>"); }
	my($temp,@bdsh,$hh,$bbase,$name,$bid,$bhere,$access);
	$temp = qq~<script language="JavaScript">
<!--
function JumpTo(ghere) {
 if(ghere != '') { location = "$surl,v=mindex,b="+ghere; }
}
//-->
</script>
<select name="JumpZ" onChange="JumpTo(this.value);">
<option value="">- $boardnm (current location)</option><option value="">-----------------------</option>~;
	foreach(@catbase) {
		($t,$t,$access,$bhere) = split(/\|/,$_);
		if($access ne $settings[4] && $settings[4] ne 'Administrator') { next; }
		@bdsh = split("/",$bhere);
		foreach $hh (@bdsh) {
			foreach $bbase (@boardbase) {
				($bid,$t,$t,$name) = split("/",$bbase);
				if($bid eq $URL{'b'} || $bid ne $hh) { next; }
				$temp .= qq~<option value="$bid"> - $name</option>~;
				last;
			}
		}
	}
	$temp .= qq~</select>~;
	return($temp);
}

sub FindStatus {
	my($temp);
	if($type) { $temp = 'locked'; }
	elsif($replies > $vhtdmax) { $temp = 'veryhotthread'; }
	elsif($replies > $htdmax) { $temp = 'hotthread'; }
		else { $temp = 'thread'; }
	if($poll && $type) { $temp = 'poll_lock'; }
	elsif($poll) { $temp = 'poll_icon'; }
	if($stickme{$messid} && $type && $temp ne 'poll_icon') { $temp = 'sticky_lock'; }
	elsif($stickme{$messid} && $temp eq 'poll_icon') { $temp = 'poll_sticky'; }
	elsif($stickme{$messid}) { $temp = 'sticky'; }
	return($temp);
}

sub CensorList {
	if($CensorLoad) { return; }
	fopen(FILE,"$prefs/Censor.txt");
	@censor = <FILE>;
	fclose(FILE);
	chomp @censor;
	$CensorLoad = 1;
}

sub BoardUsers {
	$cnt = 0;
	$gcnt = 0;
	fopen(FILE,"$prefs/Active.txt");
	@userson = <FILE>;
	fclose(FILE);
	chomp @userson;

	for($i = 0; $i < @memgrps; $i++) {
		if($i > 6) { ($t,$t,$t,$t,$t,$t,$t,$clr) = split(",",$memgrpp[$i]); } else { $clr = $memgrpp[$i]; }
		$gcolors{$memgrps[$i]} = $clr;
	}

	foreach(@userson) {
		($luser,$t,$hidden,$t,$cbrd) = split(/\|/,$_);
		if($cbrd ne $URL{'b'}) { next; }
		loaduser($luser);
		if($userset{$luser}->[1] ne '') {
			if($gcolors{$userset{$luser}->[4]}) { $duser = qq~<font color="$gcolors{$userset{$luser}->[4]}"><b>$userset{$luser}->[1]</b></font>~; }
				else { $duser = $userset{$luser}->[1]; }
			if($hidden && $settings[4] ne 'Administrator') { next; }

			$activeusers .= qq~<a href="$scripturl,v=profile,a=view,u=$luser">$duser</a>, ~;
			++$cnt;
		} else {
			++$gcnt;
		}
	}
	$activeusers =~ s/, \Z//;
	if(!$activeusers) { $activeusers = $txt['716']; }
}
1;