####################################################
# Blah Software Code      |    Software Version: 1 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2002 e-blah!                  #
# All Rights Reserved                              #
####################################################

%Actions = ( # Action Numbers (speeds up process)
	1 => 'After',
	2 => 'Replace',
	3 => 'Before'
);

sub SourceMod {
	&is_admin;
	if($URL{'p'} eq 'install') { &InstallMod; }
	elsif($URL{'p'} eq 'create') { &CreateMod; }
	elsif($URL{'p'} eq 'browser') { &Browser; }

	$title = "Modification Center";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="700" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> Browsing Avalible Modifications</b></font></td>
 </tr>
EOT
	opendir(DIR,"$root/Mods/");
	@themes = readdir(DIR);
	closedir(DIR);
	foreach(@themes) {
		if($_ =~ m/(.*)(.v1m)/) {
			if($themelist) { $hr = qq~<hr size="1" color="$color{'border'}">~; };
			if(-e("$root/Mods/$1.installed")) { $install = 'Deinstall'; } else { $install = 'Install'; }
			$about = '';
			$author = '';
			$mver = '';
			$bver = '';
			require("$root/Mods/$1.v1m");
			$name = $1;
			$name2 = $name;
			$name =~ s/ /\+/gsi;
			$explain = '';
			if($about) { $explain = qq~<br><b>- About this Mod:</b> $about~; }
			if($author) { $explain .= qq~<br><b>- Author of this Mod:</b> $author~; }
			if($msite) { $explain .= qq~<br><b>- Authors Website:</b> <a href="$msite">$msite</a>~; }
			if($mver) { $explain .= qq~<br><b>- Mod Version:</b> $mver~; }
			if($bver) { $explain .= qq~<br><b>- Install on this Blah Version(s):</b> $bver~; }
			$name2 = $mname ? $mname : $name2;
			$themelist .= qq~$hr<b> $name2</b>$explain<br> - <a href="$scripturl,v=admin,a=sourcemod,p=install,m=$name">$install</a><br> - <a href="$scripturl,v=admin,a=sourcemod,p=install,m=$name,t=1">Test $install</a><br> - <a href="$scripturl,v=admin,a=sourcemod,p=create,m=$name">Modify</a>~;
		}
	}
	if(!$themelist) { $themelist = "<i>None</i>"; }
	print <<"EOT";
 <tr>
  <td bgcolor="$color{'win'}"><font size="1">You can install (or deinstall) the following modifications ...<br>Please note that only <b>Version 1</b> modifications are allowed to be installed (or deinstalled) on this board (this version is for 2 or greater of Blah). To install new modifications, upload them to the 'Root/Mods' directory on your server.</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}"><font size="1">$themelist</font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1"><b>- <a href="$scripturl,v=admin,a=sourcemod,p=create">Build a New Modification</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" align="center"><font size="1">You are using the "<b>Source Code Mod</b>", or "<b>Modification Center</b>", which comes free with the e-blah! message board system.<br>Download <b>new versions</b> of the <b>Modification Center</b> from the <b><a href="http://starsabers.swsource.net/blah/">Blah Website</a></b>.<br><b>Supported Modifications:</b> Version 1 Mods (v1m)<br><b>Software Version:</b> 1 Alpha<br><b>Software:</b> Copyright 2002 e-blah! - all rights reserved.<br><b>License Agreement:</b> You agreed to the license when you installed Blah, for a copy of the agreement, look at your Blah package.</font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub InstallMod {
	&is_admin;
	$URL{'m'} =~ s/\+/ /gsi;
	if(!-e("$root/Mods/$URL{'m'}.v1m")) { &error("Could not find $URL{'m'}.v1m"); }
	require("$root/Mods/$URL{'m'}.v1m");

	$title = "Installed";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="700" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> Installed</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="2">
   <table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align="center" width="650">
    <tr>
     <td bgcolor="$color{'titlebg'}"><font size="1"><b> Do the Following Actions</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}"><font size="1">
EOT
	foreach(@files) {
		($file,$keys) = split(/\|/,$_);
		++$keys;
		$filemod = $file;
		$filemod =~ s/Code\//$code\//gsi;
		$filemod =~ s/Root\//$root\//gsi;
		if($i) { $br = "<br>"; }
		fopen(FILE,"$filemod");
		@modify = <FILE>;
		fclose(FILE);
		chomp @modify;
		$ferror = '';
		if($modify[0] eq '') { $ferror = qq~<font color="red" size="1"> <b>:: File Not Found or Incomplete</b></font>~; $error = 1; $e{$filemod} = 1; }
		print qq~$br<font size="2"><b>Modify File:</b> $file$ferror</font><hr size='1' color='$color{'border'}'>~;
		$onestring = '';
		foreach(@modify) { $onestring .= "$_\\n"; }
		for($i = 1; $i < $keys; $i++) {
			$action = '';
			for($z = 0; $z < 4; $z++) {
				if($change{$file,$Actions{$z}}->[$i]) { $action = $Actions{$z}; }
			}
			if($action eq '') { $action = "Unknown (or error)"; }

			if(!-e("$root/Mods/$URL{'m'}.installed")) {
				$test = Format($change{$file,'s'}->[$i]);
				$test =~ s/\t/ /g;
				print "<b>Source Code:</b><blockquote>$test</blockquote>";
				$test = Format($change{$file,$action}->[$i]);
				$test =~ s/\t/ /g;
				print "<b>$action:</b><blockquote>$test</blockquote>";
				$find = $change{$file,'s'}->[$i];
				$replace = $change{$file,$action}->[$i];
				$install = 1;
			} else {
				$test = Format($change{$file,$action}->[$i]);
				$test =~ s/\t/ /g;
				print "<b>Source Code:</b><blockquote>$test</blockquote>";
				$test = Format($change{$file,'s'}->[$i]);
				$test =~ s/\t/ /g;
				print "<b>$action:</b><blockquote>$test</blockquote>";
				$find = $change{$file,$action}->[$i];
				$replace = $change{$file,'s'}->[$i];
			}
			$find =~ s~\n~\\n~gsi;
			$find =~ s/\cM//g;
			$replace =~ s~\n~\\n~gsi;
			$replace =~ s/\cM//g;
			$ok = 0;
			if($action eq 'Replace') {
				if($onestring =~ s~\Q$find\E~$replace~g) { print "<b>-- Modification: OK</b><br>"; }
					else { print qq~<b><font color="red">-- Modification: Error :: Not Found in File</font></b><br>~; $error = 1; $e{$filemod} = 1; }
			}
			elsif($action eq 'After' && $install) {
				if($onestring =~ s~\Q$find\E~$find\n$replace~g) { print "<b>-- Modification: OK</b><br>"; }
					else { print qq~<b><font color="red">-- Modification: Error :: Not Found in File</font></b><br>~; $error = 1; $e{$filemod} = 1; }
			}
			elsif($action eq 'Before' && $install) {
				if($onestring =~ s~\Q$find\E~$replace\n$find~g) { print "<b>-- Modification: OK</b><br>"; }
					else { print qq~<b><font color="red">-- Modification: Error :: Not Found in File</font></b><br>~; $error = 1; }
			}
			elsif($action eq 'Before' && !$install) {
				if($onestring =~ s~\Q$find\n$replace\E~$replace~g) { print "<b>-- Modification: OK</b><br>"; }
					else { print qq~<b><font color="red">-- Modification: Error :: Not Found in File</font></b><br>~; $error = 1; }
			}
			elsif($action eq 'After' && !$install) {
				if($onestring =~ s~\Q$replace\n$find\E~$replace~g) { print "<b>-- Modification: OK</b><br>"; }
					else { print qq~<b><font color="red">-- Modification: Error :: Not Found in File</font></b><br>~; $error = 1; }
			} else { print qq~<b><font color="red">-- Not Found in '$file'!</font></b><br>~; $error = 1; $e{$filemod} = 1; }
			$modify{$filemod} = $onestring; # This is a protection against errors
		}
	}
	if($URL{'s'}) { $error = 0; } # Turn off error checks and install
	print <<"EOT";
    <tr>
     <td bgcolor="$color{'titlebg'}"><font size="1"><b> Modifing Files</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}"><font size="1">
EOT
	if($error && $URL{'t'}) { print qq~There are one or more errors, this modification <b>WILL NOT</b> install correctly. Please contact this modifications author.<hr color="$color{'border'}" size="1">~; }
	elsif($error) { print qq~There has been one or more errors finding strings, and the installation (or deinstallation) of this modification has been halted. You can <a href="$scripturl,v=admin,a=sourcemod,p=install,m=Test,s=1">Install Anyway</a>, which is <b>NOT</b> recommended, or you can contact the writer of this modification for an update or fix (if one may exist).<hr color="$color{'border'}" size="1">~; }
	elsif($URL{'t'}) { print qq~This modification should install okay. <a href="$scripturl,v=admin,a=sourcemod,p=install,m=Test,s=1">Click here to install</a>.<hr color="$color{'border'}" size="1">~; $error = 1; }
	while(($filename,$write) = each(%modify)) {
		if($error) { last; }
		$postinstalle = '';
		$time = time;
		rename($filename,"$filename.bkup.$time");
		$write =~ s/\\n/\n/gsi;
		fopen(FILE,">$filename");
		print FILE $write;
		fclose(FILE);
		if($e{$filename}) { $postinstalle = qq~ :: <font color="red">File <b>MAY</b> Be Corrupt (there were errors in installation run-through)</font>~; }
		print qq~<b>File Modified:</b> $filename$postinstalle<br>~;
		delete($modify{$file});
	}
	if($error) { print qq~<b>Files Modified:</b> <i>None</i>~; }

	if(-e("$root/Mods/$URL{'m'}.installed") && !$error) { unlink("$root/Mods/$URL{'m'}.installed"); }
	elsif(!$error) {
		fopen(FILE,">$root/Mods/$URL{'m'}.installed");
		fclose(FILE);
	}
	print <<"EOT";
     </font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><a href="$scripturl,v=admin,a=sourcemod"><b>Ok</b></a></font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub CreateMod {
	&is_admin;
	if($URL{'m'} eq '') {
		$title = "Build a New Modification";
		&header;
		print <<"EOT";
<SCRIPT LANGUAGE="JavaScript">
<!-- Start
function Submit() {
 document.sform.submit.disabled = true;
}
// End -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="400" align="center">
 <tr><form action="$scripturl,v=admin,a=sourcemod,p=create,m=new" method="post" name="sform" onSubmit="Submit()">
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">Before you can begin building this modification, you must give this modification a name.</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td align="right"><font size="2"><b>Name of Modification:</b></font></td>
     <td><input type="text" name="name" value=""></td>
    </tr>
   </table></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><input type="submit" value=" Create " name="submit"></td>
 <form></tr>
</table>
EOT
		&footer;
		exit;
	} elsif($URL{'m'} eq 'new') {
		$FORM{'name'} =~ s/[#%+,\\\/:?"<>'|@^\$\&~'\]\[\;{}!`=-]//gsi;
		$FORM{'name'} =~ s/ //gsi;
		if($FORM{'name'} eq '') { &error("The modification name is blank."); }
		if(-e("$root/Mods/$FORM{'name'}.v1m")) { &error("The specified mod already exists."); }
		fopen(FILE,">$root/Mods/$FORM{'name'}.v1m");
		print FILE "1;";
		fclose(FILE);
		redirect("$scripturl,v=admin,a=sourcemod,p=create,m=$FORM{'name'}");
	}
	if(!-e("$root/Mods/$URL{'m'}.v1m")) { &error("Cannot find the modification you specified."); }
	if($FORM{'spec'}) { $URL{'f'} = "$FORM{'folder'}/$FORM{'spec'}"; }
	if($URL{'s'} || ($URL{'d'} && $URL{'f'} && $FORM{'action'} && $FORM{'searchfor'})) { &Save; }
	$modifing = $URL{'f'} ? $URL{'f'} : "<i>No File To Modify</i>";
	$title = "Build a Modification";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr><form action="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=$URL{'d'},n=$URL{'n'}" method="post" name="save">
  <td bgcolor="$color{'titlebg'}" colspan="2"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="2"><font size="1">You currently have a modification open and are modifying it. Changes are made <b>instantly</b>, so it is recommended you make a backup before modifying a modification.<br>To <b>delete</b> an action to a file, open the file, and choose the action (from the right pane) then click "<b>Delete Action</b>" (right pane).<br>To <b>modify</b> or <b>add</b> an action to a file, open the file, and choose the action (from the right pane or from the "Specify New Action" section) then click "<b>Save Action</b>" (right pane) when you are finished modifying.<br><b>Version of Source Code Mod:</b> 1 Alpha</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="2"><font size="2"><b><img src="$images/open_thread.gif"> Currently Modifing File:</b> "$modifing" <b>in Modification:</b> "$URL{'m'}"</font><br><font size="1">  <b>- <a href="$scripturl,v=admin,a=sourcemod,p=browser,m=$URL{'m'}">Open a New File for Modification</a></b></font></td>
 </tr>
EOT
	require("$root/Mods/$URL{'m'}.v1m");
	foreach(@files) {
		($file,$keys) = split(/\|/,$_);
		$filemod .= qq~<b><a href="$scripturl,v=admin,a=sourcemod,p=create,f=$file,m=$URL{'m'}">$file</a></b> ($keys actions)<br>~;
		++$keys;
		if($file ne $URL{'f'}) { next; }
		for($i = 1; $i < $keys; $i++) {
			for($z = 0; $z < 4; $z++) {
				if($change{$file,$Actions{$z}}->[$i]) { $action = $Actions{$z}; }
			}
			$acts .= qq~<b><a href="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=$action,n=$i">$action</a></b> - Action $i<br>~;
			if($URL{'n'} == $i) {
				$search = $change{$file,'s'}->[$i];
				$changes = $change{$file,$action}->[$i];
				$delete = qq~ <input type="submit" value=" Delete Action " name="delete">~;
			}
		}
	}
	if(!$filemod) { $filemod = "There are currently no files to edit and no actions to preform ..."; }
	if($URL{'d'} && $URL{'f'}) {
		if($URL{'d'} eq 'after') { $action = "Add code <b>After</b> code searched for ..."; }
		elsif($URL{'d'} eq 'before') { $action = "Add code <b>Before</b> code searched for ..."; }
			else { $action = "<b>Replace</b> code searched for with ..."; }
		$preform = <<"EOT";
<b>Search</b> for the following code ...
<textarea name="searchfor" wrap="virtual" rows="5" cols="112">$search</textarea><br><br>

$action
<textarea name="action" wrap="virtual" rows="5" cols="112">$changes</textarea><br><br>
<input type="submit" value=" Save Action " name="submit">$delete<br>
<br><font size="1"><b>Adding Tabs:</b> (\\t) is the eqivilent one (1) tab (if you do not use copy / paste)</font>
EOT
	} else { $preform = "You must first specify the file you wish to apply a modification to, or specify the action you wish to apply to the file open."; }

	$version =~ s/(.+?) \((.+?)\)//gsi;
	$version = $1;
	$bver = $bver ? $bver : $version;
	$mname = $mname ? $mname : $URL{'m'};
	$about = Unformat($about);

	if(!$acts) { $acts = "This file currently does not have any actions to it."; }
	print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> Action to Preform</b></font></td>
  <td bgcolor="$color{'catbg'}" width="20%"><font size="2"><b> Current Actions</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" valign="top"><font size="1">$preform</font></td>
  <td bgcolor="$color{'win'}" width="20%" valign="top"><font size="1">$acts</font></td>
 </form></tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="1"><b> Specify New Action</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="2"><font size="1"><b>- <a href="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=After">Add New Code After</a><br>- <a href="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=Before">Add New Code Before</a><br>- <a href="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=Replace">Replace with New Code</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="1"><b> Current Files to Modify</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="2"><font size="1">$filemod</font></td>
 </tr><tr><form action="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=$URL{'d'},n=$URL{'n'},s=1" method="post" name="save">
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="1"><b> Edit Current Modification Information</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="2">
   <table cellpadding="3" cellspacing="0">
    <tr>
     <td align="right"><font size="1"><b>Modification Title:</b></font></td>
     <td><input type="text" name="title" value="$mname" size="50"></td>
    </tr><tr>
     <td align="right"><font size="1"><b>Author:</b></font></td>
     <td><input type="text" name="author" value="$author" size="40"></td>
    </tr><tr>
     <td align="right"><font size="1"><b>Your Website:</b></font></td>
     <td><input type="text" name="msite" value="$msite" size="35"></td>
    </tr><tr>
     <td align="right"><font size="1"><b>Modification Version:</b></font></td>
     <td><input type="text" name="mver" value="$mver" size="13"></td>
    </tr><tr>
     <td align="right"><font size="1"><b>Blah Version to Install On:</b></font></td>
     <td><input type="text" name="bver" value="$bver" size="13"></td>
    </tr><tr>
     <td align="right" valign="top"><font size="1"><b>Modification Information:</b></font></td>
     <td><textarea name="about" wrap="virtual" rows="3" cols="50">$about</textarea></td>
    </tr><tr>
     <td colspan="2"><input type="submit" name="submit" value=" Save Information "></td>
    </tr>
   </table>
  </td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}

sub QuickFormat {
	($format) = $_[0];
	$format =~ s/\(\\t\)/\t/gsi;
	$format =~ s/'/\\'/gsi;
	return($format);
}

sub Save {
	&is_admin;
	$key = 0;
	require("$root/Mods/$URL{'m'}.v1m");

	$sfor = QuickFormat($FORM{'searchfor'});
	$act = QuickFormat($FORM{'action'});

	fopen(FILE,">$root/Mods/$URL{'m'}.v1m");
	foreach(@files) {
		($file,$keys) = split(/\|/,$_);
		if($file eq $URL{'f'} && !$URL{'s'}) {
			$key = $keys;
			if(!$URL{'n'} && !$FORM{'delete'}) { ++$key; }
			elsif($URL{'n'} && $FORM{'delete'}) { --$key; }
			if($key == 0) { next; }
			$all .= qq~"$file|$key",~;
		} else { $all .= qq~"$file|$keys",~; }

		++$keys;
		$sds = 1;
		for($i = 1; $i < $keys; $i++) {
			$action = '';
			for($z = 0; $z < 4; $z++) {
				if($change{$file,$Actions{$z}}->[$i]) { $action = $Actions{$z}; }
			}

			if($action) {
				if($file eq $URL{'f'} && $i == $URL{'n'} && !$URL{'s'}) {
					$change{$file,'s'}->[$i] = $sfor;
					$change{$file,$action}->[$i] = $act;
				}
				if($FORM{'delete'} && $URL{'n'} == $i && $URL{'f'} eq $file) { next; }
				$temp1 = QuickFormat($change{$file,'s'}->[$i]);
				$temp2 = QuickFormat($change{$file,$action}->[$i]);
				$topmods .= "# $sds\n\$change{'$file','s'}->[$sds] = '$temp1';\n";
				$topmods .= "\$change{'$file','$action'}->[$sds] = '$temp2';\n";
				++$sds;
			}
		}
	}
	if(!$key && !$URL{'n'} && !$URL{'s'}) { ++$key; $all .= qq~"$URL{'f'}|$key",~; }
	$all =~ s/,\Z//gsi;
	print FILE "\@files = ($all);\n$topmods";
	if(!$URL{'n'} && !$FORM{'delete'} && !$URL{'s'}) {
		print FILE "# $key\n\$change{'$URL{f}','s'}->[$key] = '$sfor';\n";
		print FILE "\$change{'$URL{f}','$URL{d}'}->[$key] = '$act';\n";
	}
	if($URL{'s'}) {
		while(($in,$out) = each(%FORM)) {
			$out = Format($out);
			$out = QuickFormat($out);
			$FORM{$in} = $out;
		}
		if($FORM{'title'} ne $URL{'m'}) { print FILE qq~\$mname = '$FORM{title}';\n~; }
		if($FORM{'author'}) { print FILE qq~\$author = '$FORM{author}';\n~; }
		if($FORM{'about'}) { print FILE qq~\$about = '$FORM{about}';\n~; }
		if($FORM{'mver'}) { print FILE qq~\$mver = '$FORM{mver}';\n~; }
		if($FORM{'bver'}) { print FILE qq~\$bver = '$FORM{bver}';\n~; }
		if($FORM{'msite'}) { print FILE qq~\$msite = '$FORM{msite}';\n~; }
	} else {
		$mname = QuickFormat($mname);
		$author = QuickFormat($author);
		$about = QuickFormat($about);
		$mver = QuickFormat($mver);
		$bver = QuickFormat($bver);
		$msite = QuickFormat($msite);
		print FILE qq~\$mname = '$mname';\n\$author = '$author';\n\$about = '$about';\n\$mver = '$mver';\n\$bver = '$bver';\n\$msite = '$msite';\n~;
	}
	print FILE "1;";
	fclose(FILE);

	&redirect("$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'}");
}

sub Browser {
	&is_admin;
	opendir(DIR,"$code/");
	@directory = readdir(DIR);
	closedir(DIR);
	foreach(@directory) {
		if($_ eq '.' || $_ eq '..') { next; }
		$codedir .= qq~<a href="$scripturl,v=admin,a=sourcemod,p=create,f=Code/$_,m=$URL{'m'}">$_</a><br>~;
	}
	opendir(DIR,"$root/");
	@directory = readdir(DIR);
	closedir(DIR);
	foreach(@directory) {
		if($_ eq '.' || $_ eq '..' || $_ eq 'Boards' || $_ eq 'Code' || $_ eq 'Members' || $_ eq 'Messages' || $_ eq 'Prefs' || $_ eq 'Themes' || $_ eq 'Mods') { next; }
		$rootdir .= qq~<a href="$scripturl,v=admin,a=sourcemod,p=create,f=Root/$_,m=$URL{'m'}">$_</a><br>~;
	}
	$title = "Browsing Current Code to Modify";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="400" align="center">
 <tr><form action="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'}" method="post" name="save">
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> Directory: Root</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$rootdir</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> Directory: Code</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$codedir</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> Select File</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}">
   <table cellpadding="4" cellspacing="0">
    <tr>
     <td align="right"><font size="2"><b>Folder:</b></font></td>
     <td><select name="folder">
      <option value="Root">Root</option>
      <option value="Code">Code</option>
     </select></td>
    </tr><tr>
     <td align="right"><font size="2"><b>File In Directory:</b></font></td>
     <td><input type="text" name="spec" value=""></td>
    </tr><tr>
     <td align="right" colspan="2"><input type="submit" value=" Select Directory " name="dir"></td>
    </tr>
   </table>
  </td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}
1;